<?php

namespace Shop\Controller;


use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Shop\DB\CustomersDB;
use Shop\DB\CustomerOrderDB;

class Shop {
  
  protected $container;
  protected $twig;

  public function __construct(ContainerInterface $container){
    $this->container = $container;

  }
public function customers(ServerRequestInterface $request, ResponseInterface $response, array $args){

  $container = $this->container;
  $twig = $container->get('twig');
  $db = new CustomersDB($this->container);
  $customers = $db->loadCust();

  $var = ["customerList" => $customers];

  $container = $this->container;


  $render = $twig->render('customers.html.twig', $var);
  $response->getBody()->write($render);
  return $response;
}
public function customerOrders(ServerRequestInterface $request, ResponseInterface $response, array $args){
  $container = $this->container;
  $twig = $container->get('twig');
  $db = new CustomerOrderDB($this->container);
  $customerOrders = $db->customerOrders($args);
  $var = ["customerOrders" => $customerOrders];

  $render = $twig->render('customerOrders.html.twig', $var);
  $response->getBody()->write($render);
  return $response;
}

public function nameCustomer(ServerRequestInterface $request, ResponseInterface $response, array $args){
  $container = $this->container;
  $twig = $container->get('twig');
  $db = new CustomerOrderDB($this->container);
  $customerName = $db->nameCustomer($args);
  $var = ["customerName" => $customerName];

  $render = $twig->render('customerOrders.html.twig', $var);
  $response->getBody()->write($render);
  return $response;
}
}